--***********************************************************
--**                   KI5 / bikinihorst                   **
--***********************************************************

MR2 = {
	parts = {
		BumperFront = {
			MR2BumperFront = {
				FrontBumper0 = "87toyotaMR2BumperFront0",
				FrontBumperA = "87toyotaMR2BumperFrontA",
				FrontBullbarA = "87toyotaMR2BullbarFrontA",
			},
			default = "first",
		},
		BumperRear = {
			MR2BumperRear = {
				BumperRear0 = "87toyotaMR2BumperRear0",
			},
			default = "first",
		},
		WindowLeftArmor = {
			MR2WindowLeftArmor = {
				MR2leftdoora = "87toyotaMR2WindowArmor",
			},
		},
		WindowRightArmor = {
			MR2WindowRightArmor = {
				MR2rightdoora = "87toyotaMR2WindowArmor",
			},
		},
		WindshieldArmor = {
			MR2WindshieldArmor = {
				MR2winda0 = "87toyotaMR2WindshieldArmor",
			},
		},
		WindshieldRearArmor = {
			MR2WindshieldRearArmor = {
				MR2windra = "87toyotaMR2WindshieldRearArmor",
			},
		},
		Sideskirts = {
			MR2Sideskirts = {
				MR2sideskirts = "87toyotaMR2Sideskirts3",
			},
			default = "trve_random",
			noPartChance = 30,
		},
		Spoiler = {
			MR2Spoiler = {
				MR2spoiler0 = "87toyotaMR2Spoiler3",
			},
			default = "trve_random",
			noPartChance = 30,
		},
		SpoilerRoof = {
			MR2SpoilerRoof = {
				MR2spoiler1 = "87toyotaMR2RoofSpoiler3",
			},
			default = "trve_random",
			noPartChance = 30,
		},
		Roofrack = {
			MR2Roofrack = {
				MR2Roofrack0 = "87toyotaMR2Roofrack3",
			},
			default = "trve_random",
			noPartChance = 95,
		},
		Mudflaps = {
			MR2Mudflaps = {
				MR2mudflaps0 = "87toyotaMR2Mudflaps3",
			},
			default = "trve_random",
			noPartChance = 20,
		},
		TireFrontLeft = {
			TireFrontLeft = {
				MR2Tire0 = "87toyotaMR2TireT13",
				MR2Tire1 = "87toyotaMR2TireT23",
			},
		},
		TireFrontRight = {
			TireFrontRight = {
				MR2Tire0 = "87toyotaMR2TireT13",
				MR2Tire1 = "87toyotaMR2TireT23",
			},
		},
		TireRearLeft = {
			TireRearLeft = {
				MR2Tire0 = "87toyotaMR2TireT13",
				MR2Tire1 = "87toyotaMR2TireT23",
			},
		},
		TireRearRight = {
			TireRearRight = {
				MR2Tire0 = "87toyotaMR2TireT13",
				MR2Tire1 = "87toyotaMR2TireT23",
			},
		},
		SpareTire = {
			MR2SpareTire = {
				MR2spare1 = "87toyotaMR2TireT13",
				MR2spare2 = "87toyotaMR2TireT23",
			},
			default = "trve_random",
			noPartChance = 10,
		},
	},
};

KI5:createVehicleConfig(MR2);


function MR2.ContainerAccess.FrontTrunk(vehicle, part, chr)
	if chr:getVehicle() then return false end
	if not vehicle:isInArea(part:getArea(), chr) then return false end
	local TrunkTwo = vehicle:getPartById("MR2TrunkDoorFront")
	if TrunkTwo and TrunkTwo:getDoor() then
		if not TrunkTwo:getInventoryItem() then return true end
		if not TrunkTwo:getDoor():isOpen() then return false end
	end
	--
	return true
end

function MR2.ContainerAccess.Roofrack(vehicle, part, chr)
	if chr:getVehicle() then return false end
	if not vehicle:isInArea(part:getArea(), chr) then return false end
	return true
end

function MR2.ContainerAccess.CenterConsole(vehicle, part, chr)
	if chr:getVehicle() == vehicle then
		local seat = vehicle:getSeat(chr)
		return seat == 1 or seat == 0;
	elseif chr:getVehicle() then
		return false
	else
		if not vehicle:isInArea(part:getArea(), chr) then return false end
		local doorPart = vehicle:getPartById("DoorFrontLeft")
		if doorPart and doorPart:getDoor() and not doorPart:getDoor():isOpen() then
			return false
		end
		return true
	end
end

--temp solution until the next round of base updates

function MR2.toggleWheel(vehicle, part, state)
	if state ~= nil
	then
		local wheelIndex = part:getWheelIndex();

		vehicle:setTireRemoved(wheelIndex, state);
	end

	local item = part:getInventoryItem();

	if item
	then
		for varModelName, varItem in pairs({
			["MR2Tire0"] = "87toyotaMR2TireT13",
			["MR2Tire1"] = "87toyotaMR2TireT23",
		})
		do
			part:setModelVisible(varModelName, item:getType() == varItem);
		end
	end

	vehicle:doDamageOverlay();
end

function MR2.InstallComplete.Tire(vehicle, part)
	MR2.toggleWheel(vehicle, part, false);
end

function MR2.UninstallComplete.Tire(vehicle, part, item)
	MR2.toggleWheel(vehicle, part, true);
end

function MR2.Init.Tire(vehicle, part, item)
	MR2.toggleWheel(vehicle, part);

    local vName = vehicle:getScript():getName();

    if not KI5.loadedParts[vName]
    then
        KI5.loadedParts[vName] = {
            rootNS = MR2,
            parts = {}
        }
    end

    if not KI5.loadedParts[vName].parts[part:getId()]
    then
        KI5.loadedParts[vName].parts[part:getId()] = true;
    end
end

function MR2.popupLights(player)
    local vehicle = player.getVehicle and player:getVehicle() or nil
        if (vehicle and string.find( vehicle:getScriptName(), "87toyotaMR2" )) then

            local part = vehicle:getPartById("MR2PopupLights")
            local opened = part:getDoor():isOpen()
            local active = vehicle:getHeadlightsOn()

            if active and opened then return end

            if not active and opened then
                vehicle:playPartAnim(part, "Close")
                vehicle:playPartSound(part, player, "Close")
                part:getDoor():setOpen(false)
                vehicle:transmitPartDoor(part)
            elseif active and not opened then
                vehicle:playPartAnim(part, "Open")
                vehicle:playPartSound(part, player, "Open")
                part:getDoor():setOpen(true)
                vehicle:transmitPartDoor(part)
            end
        end
end

Events.OnGameStart.Add(function()

    Events.OnKeyPressed.Add(function(key)
        local player = getPlayer()
        local vehicle = player and player:getVehicle() or nil
            if (vehicle and string.find( vehicle:getScriptName(), "87toyotaMR2" )) then

                local part = vehicle:getPartById("MR2Sunroof")

                if part then
                    local item = part:getInventoryItem()
                    local opened = part:getDoor():isOpen()

                    if item and opened and key == 210 then
                        vehicle:playPartAnim(part, "Close")
                        vehicle:playPartSound(part, player, "Close")
                        part:getDoor():setOpen(false)
                        vehicle:transmitPartDoor(part)
                        
                    elseif item and not opened and key == 210 then
                        vehicle:playPartAnim(part, "Open")
                        vehicle:playPartSound(part, player, "Open")
                        part:getDoor():setOpen(true)
                        vehicle:transmitPartDoor(part)
                    end
                else end
        end
    end )

end);

Events.OnPlayerUpdate.Add(MR2.popupLights);